<?php
// declaring menu, custom post types and taxonomies


///////////////////////////////////
// MENU

function fr_admin_menu() {	
	$menu_img = FR_URL.'/img/fr_menu_icon.png';
	$capability = 'edit_pages';
	
	add_menu_page('FAQ Revolution', 'FAQ Revolution', 'edit_pages', 'fr_menu', 'fr_menu', $menu_img, 56);
	
	add_submenu_page('fr_menu', __('Manage FAQs', FR_ML), __('Manage FAQs', FR_ML), $capability, 'edit.php?post_type=fr_faqs');
	add_submenu_page('fr_menu', __('FAQ Subjects', FR_ML), __('FAQ Subjects', FR_ML), $capability, 'edit-tags.php?taxonomy=fr_faq_subjs');
	
	add_submenu_page('fr_menu', __('Knowledge Base', FR_ML), __('Knowledge Base', FR_ML), $capability, 'edit.php?post_type=fr_kb');
	add_submenu_page('fr_menu', __('KB Tags', FR_ML), __('KB Tags', FR_ML), $capability, 'edit-tags.php?taxonomy=fr_kb_tags');
	
	add_submenu_page('fr_menu', __('External Links', FR_ML), __('External Links', FR_ML), $capability, 'edit.php?post_type=fr_ext_links');
	add_submenu_page('fr_menu', __('Settings', FR_ML), __('Settings', FR_ML), 'install_plugins', 'fr_settings', 'fr_settings');
	
	global $submenu;
	unset($submenu['fr_menu'][0]);
}
add_action('admin_menu', 'fr_admin_menu', 8);


// FAQs list - main menu trick
function fr_menu() { 
	wp_redirect( admin_url().'edit.php?post_type=fr_faqs');
	exit;
}

// settings
function fr_settings() {
	include_once(FR_DIR .'/settings/view.php');
}




////////////////////////////////
// FAQ CUSTOM POST TYPE 

add_action('init', 'register_cpt_fr_faq');
function register_cpt_fr_faq() {

    $labels = array( 
        'name' 					=> __('FAQs', FR_ML),
        'singular_name'		 	=> __('FAQ', FR_ML),
        'add_new' 				=> __('Add New FAQ', FR_ML),
        'add_new_item' 			=> __('Add New FAQ', FR_ML),
        'edit_item' 			=> __('Edit FAQ', FR_ML),
        'new_item' 				=> __('New FAQ', FR_ML),
        'view_item' 			=> __('View FAQ', FR_ML),
        'search_items' 			=> __('Search FAQs', FR_ML),
        'not_found' 			=> __('No FAQs found', FR_ML),
        'not_found_in_trash' 	=> __('No FAQs found in Trash', FR_ML),
        'parent_item_colon' 	=> __('Parent FAQ:', FR_ML),
        'menu_name' 			=> 'FAQ Revolution',
    );

    $args = array( 
        'labels' 			=> $labels,
        'hierarchical' 		=> false,      
        'taxonomies' 		=> array('fr_faq_subjs'),
        'supports' 			=> array('title', 'editor'),
        'public' 			=> true,
        'show_ui' 			=> true,
        'show_in_nav_menus' => false,
        'publicly_queryable' => true,
        'exclude_from_search' => true,
        'has_archive' 		=> false,
        'query_var' 		=> true,
        'can_export' 		=> true,
        'rewrite' 			=> array('slug' => get_option('fr_faq_baseurl', 'faq')),
        'capability_type' 	=> 'post',
		'show_in_menu' 		=> false,
    );
    register_post_type('fr_faqs', $args );	

	//////
	
	$labels = array( 
        'name' 					=> __('FAQ Subjects', FR_ML),
        'singular_name' 		=> __('FAQ Subject', FR_ML),
        'search_items'			=> __('Search FAQ Subjects', FR_ML),
        'popular_items' 		=> NULL,
        'all_items' 			=> __('All FAQ Subjects', FR_ML),
        'parent_item' 			=> __('Parent FAQ Subject', FR_ML),
        'parent_item_colon' 	=> __('Parent FAQ Subject:', FR_ML),
        'edit_item' 			=> __('Edit FAQ Subject', FR_ML),
        'update_item' 			=> __('Update FAQ Subject', FR_ML),
        'add_new_item'			=> __('Add New FAQ Subject', FR_ML),
        'new_item_name' 		=> __('New FAQ Subject', FR_ML),
        'separate_items_with_commas' => __('Separate faq subjects with commas', FR_ML),
        'add_or_remove_items' 	=> __('Add or remove FAQ Subjects', FR_ML),
        'choose_from_most_used' => __('Choose from most used FAQ Subjects', FR_ML),
        'menu_name' 			=> __('FAQ Subjects', FR_ML),
    );

    $args = array( 
        'labels' 			=> $labels,
        'public' 			=> false,
        'show_in_nav_menus' => false,
        'show_ui' 			=> true,
        'show_tagcloud'		=> false,
        'hierarchical' 		=> true,
        'rewrite' 			=> false,
        'query_var' 		=> true,
		'update_count_callback' => '_update_generic_term_count'
    );
    register_taxonomy('fr_faq_subjs', array('fr_faqs'), $args);
}




// FAQs page template
function fr_faq_pag_template($single) {
    global $post;
	
	if(isset($post) && is_object($post) && $post->post_type == 'fr_faqs') {
		global $wp_query;
		$wp_query->is_page = true;
		
		return get_template_directory() .'/'. get_option('fr_faq_pag_template', 'page.php');
	}
	
	return $single;
}
add_filter('single_template', 'fr_faq_pag_template', 100);




// fix to set the taxonomy and user pages as menu page sublevel
function fr_faq_subjs_menu_fix($parent_file) {
	global $current_screen;

	// hack for faq subjects taxonomy
	if(isset($current_screen->taxonomy)) {
		$taxonomy = 'fr_faq_subjs';
		if($taxonomy == $current_screen->taxonomy) {
			$parent_file = 'fr_menu';
		}	
	}
	
	// hack for faqs
	if(isset($current_screen->base)) {
		$page_type = 'fr_faqs';
		if(
			($current_screen->base == 'post' && $current_screen->id == $page_type) || 
			(isset($_REQUEST['post_type']) && $_REQUEST['post_type'] == $page_type)
		) {			
			global $submenu_file;
			$submenu_file = 'edit.php?post_type=fr_faqs';
			$parent_file = 'fr_menu';
		}
	}
	
	return $parent_file;
}
add_action('parent_file', 'fr_faq_subjs_menu_fix');



// customize messages
function fr_updated_messages( $messages ) {
	global $post;
	
	$messages['fr_faqs'] = array(
		0 => '', // Unused. Messages start at index 1.
		1 => __('FAQ updated', FR_ML),
		2 => __('FAQ updated', FR_ML),
		3 => __('FAQ deleted', FR_ML),
		4 => __('FAQ updated', FR_ML),
		/* translators: %s: date and time of the revision */
		5 => isset($_GET['revision']) ? sprintf( __('FAQ restored to revision from %s', FR_ML), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
		6 => __('FAQ published', FR_ML),
		7 => __('FAQ saved', FR_ML),
		8 => __('FAQ submitted', FR_ML),
		9 => sprintf( __('FAQ scheduled for: <strong>%1$s</strong>', FR_ML), date_i18n( __('M j, Y @ G:i' ), strtotime( $post->post_date ))),
		10 => __('FAQ draft updated', FR_ML),
	);
	
	return $messages;
}
add_filter('post_updated_messages', 'fr_updated_messages');



// edit FAQs submitbox - hide useless features
function fr_faqs_custom_submitbox() {
	global $post_type;

    if ($post_type == 'fr_faqs') {
		?>
		<style type="text/css">
		#visibility,
		#preview-action,

		#postexcerpt .inside > p {
			display: none !important;	
		}
		</style>
        <?php
	}
}
add_action('admin_head', 'fr_faqs_custom_submitbox');




//////////////////////////////////////
// ENABLE FAQ FILTER BY SUBJECT

function fr_faqs_filter_by_subj() {
    global $typenow, $wp_query;
	
    if ($typenow == 'fr_faqs') {
        $taxonomy = 'fr_faq_subjs';
		
		$sel = (isset($wp_query->query[$taxonomy])) ? $wp_query->query[$taxonomy] : ''; 
		
        wp_dropdown_categories(array(
            'show_option_all' =>  __("Any subject", FR_ML),
            'taxonomy'        =>  $taxonomy,
            'name'            =>  $taxonomy,
            'orderby'         =>  'name',
            'selected'        =>  $sel,
            'hierarchical'    =>  false,
            'depth'           =>  1,
            'show_count'      =>  false,
            'hide_empty'      =>  true
        ));
    }
}
add_action('restrict_manage_posts','fr_faqs_filter_by_subj');




// customize FAQs custom post type table
function fr_faqs_edit_pt_table_head($columns) {
	$new_cols = array();
	
	$new_cols['cb'] 			= '<input type="checkbox" />';
	$new_cols['fr_id'] 			= 'ID';
	$new_cols['title'] 			= __('Title', 'column name');
	$new_cols['fr_faq_type'] 	= __('Type', FR_ML);
	$new_cols['fr_faq_subjs'] 	= __('Subjects', FR_ML);
	$new_cols['date'] 			= __('Date', 'column name');
	$new_cols['fr_faq_order']	= __('Order', FR_ML);
	
	if(get_option('fr_use_rating')) {
		$new_cols['fr_rating']	= __('Rating', FR_ML);	
	}
	
	return $new_cols;
}
add_filter('manage_edit-fr_faqs_columns', 'fr_faqs_edit_pt_table_head', 10, 2);



function fr_faqs_edit_pt_table_body($column_name, $id) {
	switch ($column_name) {
		
		case 'fr_id' :
			echo $id; 
			break;
		
		
		case 'fr_faq_type' :
			echo (get_post_meta($id, 'fr_faq_type', true) == 'basic') ? __('Basic (text only)', FR_ML) : __('Choice-based', FR_ML); 
			break;
		
		
		case 'fr_faq_subjs' :
			$subjs = get_the_terms($id, 'fr_faq_subjs');
            if (is_array($subjs)) {
				$faq_subjs = array();
				
				foreach($subjs as $subj) { 
					$faq_subjs[] = '<a href="'. admin_url() .'/term.php?taxonomy=fr_faq_subjs&tag_ID='. $subj->term_id .'" target="_blank">'. $subj->name .'</a>';
				}
				echo implode(', ', $faq_subjs);
			}
			else {echo '—';}
			break;
			
			
		case 'fr_faq_order' :
			echo (!(int)get_post_meta($id, 'fr_sort_order', true)) ? '—' : (int)get_post_meta($id, 'fr_sort_order', true); 
			break;
			
			
		case 'fr_rating' :
			$upvotes 	= (int)get_post_meta($id, 'fr_upvotes', true); 
			$downvotes 	= (int)get_post_meta($id, 'fr_downvotes', true); 
			
			$up_nocolor_class 	= (!$upvotes) ? 'fr_nocolor_rating' : ''; 
			$down_nocolor_class = (!$downvotes) ? 'fr_nocolor_rating' : ''; 
			
			echo '
			<span class="fr_upvote_color '. $up_nocolor_class .'"><i class="dashicons dashicons-thumbs-up"></i>'. 	$upvotes .'</span>
			<span class="fr_downvote_color '. $down_nocolor_class .'"><i class="dashicons dashicons-thumbs-down"></i>'. $downvotes .'</span>';
			break;
	}
	return true;
}
add_action('manage_fr_faqs_posts_custom_column', 'fr_faqs_edit_pt_table_body', 10, 2);




/* Enable sorting by order in FAQs list */
function fr_custom_faq_sort_in_admin( $columns ) {	
	$columns['fr_id'] = 'ID';
	$columns['fr_faq_order'] = 'fr_sort_order';

	return $columns;
}
add_filter('manage_edit-fr_faqs_sortable_columns', 'fr_custom_faq_sort_in_admin');


function fr_apply_custom_faq_sort_in_admin( $query ) {
	if(is_admin()) {
		$orderby = $query->get('orderby');
		
		if($orderby == 'fr_sort_order') {
			$query->set('meta_key', 'fr_sort_order');
			$query->set('orderby', 'meta_value_num');
		}
	}
}
add_action('pre_get_posts', 'fr_apply_custom_faq_sort_in_admin');











///////////////////////////////////
// KNOWLEDGE BASE CUSTOM POST TYPE 

add_action('init', 'register_cpt_fr_kb');
function register_cpt_fr_kb() {
	$public_tags = get_option('fr_public_kb_tags'); 
	
    $labels = array( 
        'name' 					=> __('Articles', FR_ML),
        'singular_name'		 	=> __('Article', FR_ML),
        'add_new' 				=> __('Add New Article', FR_ML),
        'add_new_item' 			=> __('Add New Article', FR_ML),
        'edit_item' 			=> __('Edit Article', FR_ML),
        'new_item' 				=> __('New Article', FR_ML),
        'view_item' 			=> __('View Article', FR_ML),
        'search_items' 			=> __('Search Articles', FR_ML),
        'not_found' 			=> __('No articles found', FR_ML),
        'not_found_in_trash' 	=> __('No articles found in Trash', FR_ML),
        'parent_item_colon' 	=> __('Parent Article:', FR_ML),
        'menu_name' 			=> __('Knowledge Base', FR_ML),
    );

    $args = array( 
        'labels' 			=> $labels,
        'hierarchical' 		=> false,      
        'taxonomies' 		=> array('fr_kb_tags'),
        'supports' 			=> array('title', 'editor', 'thumbnail'),
        'public' 			=> true,
        'show_ui' 			=> true,
        'show_in_nav_menus' => true,
        'publicly_queryable' => true,
        'exclude_from_search' => false,
        'has_archive' 		=> true,
        'query_var' 		=> true,
        'can_export' 		=> true,
        'rewrite' 			=> array('slug' => get_option('fr_kb_baseurl', 'kb')),
        'capability_type' 	=> 'post',
		'show_in_menu' 		=> false,
    );
    register_post_type('fr_kb', $args );	

	//////
	
	$labels = array( 
        'name' 					=> __('Knowledge Base Tags', FR_ML),
        'singular_name' 		=> __('Tag', FR_ML),
        'search_items'			=> __('Search Tags', FR_ML),
        'popular_items' 		=> NULL,
        'all_items' 			=> __('All Tags', FR_ML),
        'parent_item' 			=> __('Parent Tag', FR_ML),
        'parent_item_colon' 	=> __('Parent Tag:', FR_ML),
        'edit_item' 			=> __('Edit Tag', FR_ML),
        'update_item' 			=> __('Update Tag', FR_ML),
        'add_new_item'			=> __('Add New Tag', FR_ML),
        'new_item_name' 		=> __('New Tag', FR_ML),
        'separate_items_with_commas' => __('Separate tags with commas', FR_ML),
        'add_or_remove_items' 	=> __('Add or remove tags', FR_ML),
        'choose_from_most_used' => __('Choose from most used tags', FR_ML),
        'menu_name' 			=> __('Knowledge Base Tags', FR_ML),
    );

    $args = array( 
        'labels' 			=> $labels,
        'public' 			=> ($public_tags) ? true : false,
        'show_in_nav_menus' => false,
        'show_ui' 			=> true,
        'show_tagcloud'		=> false,
        'hierarchical' 		=> false,
        'rewrite' 			=> ($public_tags) ? array('slug' => get_option('fr_kb_tags_baseurl', 'kb-tags')) : false,
        'query_var' 		=> true,
		'update_count_callback' => '_update_generic_term_count'
    );
    register_taxonomy('fr_kb_tags', array('fr_kb'), $args);
}



// KB page template
function fr_kb_pag_template($single) {
    global $post;
	
	if(isset($post) && is_object($post) && $post->post_type == 'fr_kb') {
		global $wp_query;
		$wp_query->is_page = true;
		
		return get_template_directory() .'/'. get_option('fr_kb_pag_template', 'page.php');
	}
	
	return $single;
}
add_filter('single_template', 'fr_kb_pag_template', 100);




// fix to set the taxonomy and user pages as menu page sublevel
function fr_kb_tags_menu_fix($parent_file) {
	global $current_screen;

	// hack for taxonomy
	if(isset($current_screen->taxonomy)) {
		$taxonomy = 'fr_kb_tags';
		if($taxonomy == $current_screen->taxonomy) {
			$parent_file = 'fr_menu';
		}	
	}
	
	// hack for articles
	if(isset($current_screen->base)) {
		$page_type = 'fr_kb';
		if(
			($current_screen->base == 'post' && $current_screen->id == $page_type) || 
			(isset($_REQUEST['post_type']) && $_REQUEST['post_type'] == $page_type)
		) {			
			global $submenu_file;
			$submenu_file = 'edit.php?post_type=fr_kb';
			$parent_file = 'fr_menu';
		}
	}
	
	return $parent_file;
}
add_action('parent_file', 'fr_kb_tags_menu_fix');




// customize messages
function fr_kb_updated_messages( $messages ) {
	global $post;
	
	$messages['fr_kb'] = array(
		0 => '', // Unused. Messages start at index 1.
		1 => __('Article updated', FR_ML),
		2 => __('Article updated', FR_ML),
		3 => __('Article deleted', FR_ML),
		4 => __('Article updated', FR_ML),
		/* translators: %s: date and time of the revision */
		5 => isset($_GET['revision']) ? sprintf( __('Article restored to revision from %s', FR_ML), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
		6 => __('Article published', FR_ML),
		7 => __('Article saved', FR_ML),
		8 => __('Article submitted', FR_ML),
		9 => sprintf( __('Article scheduled for: <strong>%1$s</strong>', FR_ML), date_i18n( __('M j, Y @ G:i' ), strtotime( $post->post_date ))),
		10 => __('Article draft updated', FR_ML),
	);
	
	return $messages;
}
add_filter('post_updated_messages', 'fr_kb_updated_messages');



//////////////////////////////////////
// ENABLE KB FILTER BY TAG

function fr_kb_filter_by_tag() {
    global $typenow;
    global $wp_query;
	
    if ($typenow == 'fr_kb') {
        $taxonomy = 'fr_kb_tags';
		
		isset($wp_query->query[$taxonomy]) ? $sel = $wp_query->query[$taxonomy] : $sel = ''; 
		
        wp_dropdown_categories(array(
            'show_option_all' =>  __("Any tag", FR_ML),
            'taxonomy'        =>  $taxonomy,
            'name'            =>  $taxonomy,
            'orderby'         =>  'name',
            'selected'        =>  $sel,
            'hierarchical'    =>  false,
            'depth'           =>  1,
            'show_count'      =>  false,
            'hide_empty'      =>  true
        ));
    }
}
add_action('restrict_manage_posts', 'fr_kb_filter_by_tag');


function fr_subj_id_to_subj_term($query) {
	global $pagenow;
    global $typenow;
	
	$filters = get_object_taxonomies($typenow);
	foreach ($filters as $tax_slug) {
		$var = &$query->query_vars[$tax_slug];
		if (isset($var) && (int)$var > 0) {
			$term = get_term_by('id', $var, $tax_slug);
			$var = $term->slug;
		}
	}
}
add_filter('parse_query', 'fr_subj_id_to_subj_term'); // use it after every restrict_manage_posts action




// customize kb custom post type table
function fr_kb_edit_pt_table_head($columns) {
	$new_cols = array();
	
	$new_cols['cb'] 			= '<input type="checkbox" />';
	$new_cols['title'] 			= __('Title', 'column name');
	
	$new_cols['fr_kb_tag'] 		= __('Tags', FR_ML);
	$new_cols['date'] 			= __('Date', 'column name');
	$new_cols['fr_kb_thumb']	= __('Featured Image', FR_ML);
	
	return $new_cols;
}
add_filter('manage_edit-fr_kb_columns', 'fr_kb_edit_pt_table_head', 10, 2);



function fr_kb_edit_pt_table_body($column_name, $id) {
	switch ($column_name) {
		
		case 'fr_kb_tag' :
			$cats = get_the_terms($id, 'fr_kb_tags');
            if (is_array($cats)) {
				$kb_cats = array();
				
				foreach($cats as $cat) {
					$kb_cats[] = '<a href="'. admin_url() .'/term.php?taxonomy=fr_kb_tags&tag_ID='. $cat->term_id .'" target="_blank">'. $cat->name .'</a>';
				}
				
				echo implode(', ', $kb_cats);
			}
			else {echo '—';}
			break;

		case 'fr_kb_thumb' :
			echo get_the_post_thumbnail($id, array(110, 110));
			break;
	
		default:
			break;
	}
	return true;
}
add_action('manage_fr_kb_posts_custom_column', 'fr_kb_edit_pt_table_body', 10, 2);











///////////////////////////////////
// EXTERNAL LINKS CUSTOM POST TYPE 

add_action('init', 'register_cpt_fr_ext_links');
function register_cpt_fr_ext_links() {

    $labels = array( 
        'name' 					=> __('External Links', FR_ML),
        'singular_name'		 	=> __('External Link', FR_ML),
        'add_new' 				=> __('Add New External Link', FR_ML),
        'add_new_item' 			=> __('Add New External Link', FR_ML),
        'edit_item' 			=> __('Edit External Link', FR_ML),
        'new_item' 				=> __('New External Link', FR_ML),
        'view_item' 			=> __('View External Link', FR_ML),
        'search_items' 			=> __('Search External Links', FR_ML),
        'not_found' 			=> __('No External Links found', FR_ML),
        'not_found_in_trash' 	=> __('No External Links found in Trash', FR_ML),
        'parent_item_colon' 	=> __('Parent External Link:', FR_ML),
        'menu_name' 			=> __('Knowledge Base', FR_ML),
    );

    $args = array( 
        'labels' 			=> $labels,
        'hierarchical' 		=> false,      
        'supports' 			=> array('title', 'excerpt'),
        'public' 			=> false,
        'show_ui' 			=> true,
        'show_in_nav_menus' => false,
        'publicly_queryable' => false,
        'exclude_from_search' => true,
        'has_archive' 		=> false,
        'query_var' 		=> true,
        'can_export' 		=> true,
        'capability_type' 	=> 'post',
		'show_in_menu' 		=> false,
    );
    
	register_post_type('fr_ext_links', $args );	
	remove_post_type_support('fr_ext_links', 'revisions');
}



// customize messages
function fr_ext_links_updated_messages( $messages ) {
	global $post;
	
	$messages['fr_ext_links'] = array(
		0 => '', // Unused. Messages start at index 1.
		1 => __('Link updated', FR_ML),
		2 => __('Link updated', FR_ML),
		3 => __('Link deleted', FR_ML),
		4 => __('Link updated', FR_ML),
		/* translators: %s: date and time of the revision */
		5 => isset($_GET['revision']) ? sprintf( __('Link restored to revision from %s', FR_ML), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
		6 => __('Link saved', FR_ML),
		7 => __('Link saved', FR_ML),
		8 => __('Link submitted', FR_ML),
		9 => sprintf( __('Link scheduled for: <strong>%1$s</strong>', FR_ML), date_i18n( __('M j, Y @ G:i' ), strtotime( $post->post_date ))),
		10 => __('Link draft updated', FR_ML),
	);
	
	return $messages;
}
add_filter('post_updated_messages', 'fr_ext_links_updated_messages');



// disable autosave for links opst type
function fr_ext_links_no_autosave() {
	
    if(get_post_type() == 'fr_ext_links') {
        wp_dequeue_script('autosave');
	}
}
add_action('admin_enqueue_scripts', 'fr_ext_links_no_autosave');



// fix to set the taxonomy and user pages as menu page sublevel
function fr_ext_links_menu_fix($parent_file) {
	global $current_screen;

	// hack for articles
	if(isset($current_screen->base)) {
		$page_type = 'fr_ext_links';
		if(
			($current_screen->base == 'post' && $current_screen->id == $page_type) || 
			(isset($_REQUEST['post_type']) && $_REQUEST['post_type'] == $page_type)
		) {			
			global $submenu_file;
			$submenu_file = 'edit.php?post_type=fr_ext_links';
			$parent_file = 'fr_menu';
		}
	}
	
	return $parent_file;
}
add_action('parent_file', 'fr_ext_links_menu_fix');



// customize ext links custom post type table
function fr_ext_links_edit_pt_table_head($columns) {
	$new_cols = array();
	
	$new_cols['cb'] 			= '<input type="checkbox" />';
	$new_cols['title'] 			= __('Title', 'column name');
	$new_cols['fr_ext_link']	= __('URL', FR_ML);
	$new_cols['date'] 			= __('Date', 'column name');
	
	return $new_cols;
}
add_filter('manage_edit-fr_ext_links_columns', 'fr_ext_links_edit_pt_table_head', 10, 2);



function fr_ext_links_edit_pt_table_body($column_name, $id) {
	switch ($column_name) {
		
		case 'fr_ext_link' :
            echo '<a href="'. get_the_excerpt($id) .'" target="_blank">'. get_the_excerpt($id) .'</a>';
			break;
	}
	return true;
}
add_action('manage_fr_ext_links_posts_custom_column', 'fr_ext_links_edit_pt_table_body', 10, 2);

