<?php
// INITIALIZE GUTEN BLOCKS AND DEFINE HANDLERS



// register blocks
function fr_guten_register() {
	if(!function_exists('register_block_type')) {return;}
	include_once(FR_DIR .'/builders_integration/guten_elements/faq/faq.php');	
}
add_action('init', 'fr_guten_register');






// enqueue scripts in gutenberg 
function fr_guten_scripts() {

	wp_enqueue_script(
		'lc_guten_toolkit',
		FR_URL .'/builders_integration/guten_elements/common.js',
		array(
			'wp-editor',
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
		'1.2.1',
		true
	);
	
	
	
	wp_enqueue_script(
		'lcweb/faq-revo',
		FR_URL .'/builders_integration/guten_elements/faq/faq.js',
		array(
			'wp-editor',
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
		FR_VER, 
		true
	);
	
	
	
	// hook for additional scripts
	if(!did_action('lc_guten_scripts')) {
		$GLOBALS['lc_guten_scripts'] = true;
		do_action('lc_guten_scripts');
	}
}
add_action('enqueue_block_editor_assets', 'fr_guten_scripts');






// hook for custom scripts in gutenberg head
if(!function_exists('lc_scripts_in_guten_head')) {
	function lc_scripts_in_guten_head() {
		do_action('lc_scripts_in_guten_head');
	}
	add_action('admin_head', 'lc_scripts_in_guten_head', 999);
}








// remote handler for ServerSideRender blocks
function fr_guten_handler($atts) {
	$code = '';
	
	ob_start();
	fr_inline_css();
	$code .= ob_get_clean();
	
	// compile atts
	$compiled = array();
	foreach($atts as $key => $val) {
		$compiled[] = $key .'="'. esc_attr($val) .'"'; 	
	}
	
	$code .= '<noscript class="fr_guten_atts" data-atts="'. esc_attr(json_encode($atts)) .'"></noscript>';
	return $code . do_shortcode('[faq-revo-searchbar '. implode(' ', $compiled) .']');
}


// ajax handler to execute dynamic javascript code on box choice
function fr_guten_async_render() {	
	$raw_atts = json_decode(stripslashes($_POST['guten_atts']), true);
	
	$atts = '';
	foreach($raw_atts as $key => $val) {
		$atts .= ' '. $key .'="'. (string)$val .'"';	
	}

	echo do_shortcode('[faq-revo-searchbar '. $atts .']');
	wp_die();
}
add_action('wp_ajax_fr_guten_async_render', 'fr_guten_async_render');

