<?php 
// filter FAQ page contents to show connected items and eventually hide elements used by the theme

function fr_faq_rewrite_url() {
	
	// flush on settings save to apply
	if(isset($_POST['fr_settings'])) {
		flush_rewrite_rules();
		update_option('fr_flush_rewrite_rules', 1);
	}
	
	$target_pags_id = (array)get_option('fr_faq_search_pag');
	
	foreach($target_pags_id as $tp_id) {
		$tp_id = (int)$tp_id;	
		$target_pag_slug = get_post_field('post_name', $tp_id);
		
		// use sub-subjects?
		if(get_option('fr_no_sub_subjs')) {
			$ss_regex = '';
			$ss_match =	'';	
			$faq_match = 2;
		} 
		else {
			$ss_regex = '([^/]*)/';
			$ss_match =	'&fr_sub_subj=$matches[2]';
			$faq_match = 3;
		}
		
		
		// need to make three in order to use only singular parameters
		// IMPORTANT - USE THIS ORDER!!
		
		$regex 		= '^'. $target_pag_slug .'/([^/]*)/'.$ss_regex.'([^/]*)/?';
		$redirect 	= 'index.php?page_id='. $tp_id .'&fr_subj=$matches[1]'. $ss_match .'&fr_faq=$matches['. $faq_match .']'; 
		add_rewrite_rule($regex, $redirect, 'top');
		
		if($ss_regex) {
			$regex 		= '^'. $target_pag_slug .'/([^/]*)/'.$ss_regex.'?';
			$redirect 	= 'index.php?page_id='. $tp_id .'&fr_subj=$matches[1]'. $ss_match; 
			add_rewrite_rule($regex, $redirect, 'top');
		}
		
		$regex 		= '^'. $target_pag_slug .'/([^/]*)/?';
		$redirect 	= 'index.php?page_id='. $tp_id .'&fr_subj=$matches[1]'; 
		add_rewrite_rule($regex, $redirect, 'top');
	}
}
add_action('admin_init', 'fr_faq_rewrite_url', 999);




// re-flush to be sure it is applied
function fr_reflush_rewrite_rules() {
	if(get_option('fr_flush_rewrite_rules')) {
		flush_rewrite_rules();
		fr_faq_rewrite_url();	
		delete_option('fr_flush_rewrite_rules');
	}
}
add_action('admin_footer', 'fr_reflush_rewrite_rules', 999);





function fr_add_rw_variables($public_query_vars) {
	$public_query_vars[] = 'fr_subj';
	
	if(!get_option('fr_no_sub_subjs')) {
		$public_query_vars[] = 'fr_sub_subj';
	}
		
	$public_query_vars[] = 'fr_faq';
	return $public_query_vars;
} 
add_filter('query_vars', 'fr_add_rw_variables', 1);
