jQuery(document).ready(function($) {
	
	var	fr_faq_cache	= [], // caching FAQ codes retrieved via AJAX
		fr_loader_code	= '<div class="fr_big_loader"></div>',
		
		fr_onpopstate	= false, // know whether system is acting after window.popstate
		fr_skip_deepl	= false, // another flag acting on fr_set_dl
		deepl_parts		= { // storing [subj, sub_subj, faq] selectors got from deeplink onpopstate 
			'subj' 		: false,
			'sub_subj'	: false,
			'faq'		: false
		},
		deepl_parts_bkp = deepl_parts;
	
	
	
	////////////////////////////////////////
	//// SUBJECTS DROPDOWN EMULATION
	
	// expand dropdown list
	$(document).on('click', '.fr_custom_dd:not(.fr_expanded_dd) > section', function() {
		
		$(this).parents('.fr_custom_dd').addClass('fr_expanded_dd');
		$(this).parents('.fr_custom_dd').find('.fr_custom_dd_list').clearQueue().slideDown(180);
	});
	$(document).on('click', '.fr_custom_dd:not(.fr_expanded_dd)', function(e) {
		if($(e.target).hasClass('fr_custom_dd')) {
			$(this).find('> section').trigger('click');	
		}
	});
	
	// close if clicks elsewhere
	$(document).on('click', '*:not(.fr_custom_dd)', function(e) {
		if( !$(e.target).hasClass('fr_custom_dd') && !$(e.target).parents('.fr_custom_dd').length) {
			
			$('.fr_expanded_dd .fr_custom_dd_list').clearQueue().slideUp(180);
			$('.fr_expanded_dd').removeClass('fr_expanded_dd');
		}
	});
	
	// close clicking on expanded dropdown
	$(document).on('click', '.fr_expanded_dd > section', function(e) {
		$(this).parents('.fr_custom_dd').find('.fr_custom_dd_list').clearQueue().slideUp(180);
		$(this).parents('.fr_custom_dd').removeClass('fr_expanded_dd');
	});
	
	
	// choose a list item 
	$(document).on('click', '.fr_custom_dd_list li:not(.fr_custom_dd_sel)', function(e) {
		
		var $subj 	= $(this),
			$dd		= $subj.parents('.fr_custom_dd'),
			val		= $subj.data('val');

		$dd.find('.fr_custom_dd_list').clearQueue().slideUp(180);
		$dd.removeClass('fr_expanded_dd');
		
		$dd.find('section').html( $subj.html() );

		// hide selected opt
		setTimeout(function() {
			$dd.find('.fr_custom_dd_list li').removeClass('fr_custom_dd_sel');
			$subj.addClass('fr_custom_dd_sel');
		}, 180);
		
        // clean search
        $subj.parents('form').find('.fr_clear_search').trigger('click');
        
		$(window).trigger('fr_dd_change', [$dd, val]); // passes dropdown object and chosen value
	});

	
	
	// avoid form submission on enter key
	$('.fr_faq_search input').keypress(function(e){
		if(e.keyCode === 13){
			e.preventDefault();
			return false;
		}
   	});
	
	
	
	
	//////////////////////////////////////////////////////////////////////////////////////
	
	
	
	
	////////////////////////////////////////
	//// ENCAPSULATE FOR MULTI-INSTANCE IN SAME PAGE 
	window.fr_init_searchbox = function(fr_id) {

		/* GLOBAL vars are in shortcode.php and filled with deeplinks
	
		 * fr_subj[fr_id]
		 * fr_sub_subj[fr_id]
		 * fr_faq[fr_id]
		 */

		var is_acting	= false, // perform ajax actions only once
			$searchbox 	= $('#'+ fr_id);

	
			////////////////////////////////////////
			// SUBJECT & SUB-SUBJECT DROPDOWNS ACTIONS
			
			$(window).on('fr_dd_change', function(e, $dd, sel_val) {
				if(!$dd.hasClass('fr_subjs_container') && !$dd.hasClass('fr_sub_subjs_container')) {
					return true;	
				}
				
				// subject
				if($dd.hasClass('fr_subjs_container')) {
					fr_subj[fr_id] = sel_val;
					
					// if not coming from deeplink - set sub-subj to "any"
					if(!fr_onpopstate) {
						fr_sub_subj[fr_id] = 'any';	
					}
					sub_subj_dd_manag();
				} 
				
				// sub-subject
				else {
					fr_sub_subj[fr_id] = sel_val;	
				}
				back_to_faqs(true);
			
			
				// manage deeplink
				setTimeout(function() {
					fr_set_dl();
				}, 180);
				
				// trigger FAQs listing
				if(!fr_onpopstate) {
					fetch_faqs();
				}
			});
			
			
			
			// wheher to show sub-subjects dropdown or hide it
			var sub_subj_dd_manag = function() {
				if(!fr_sub_subjs_list[fr_id] || typeof(fr_sub_subjs_list[fr_id][ fr_subj[fr_id] ]) == 'undefined') {
					return false;	
				}
				var obj = fr_sub_subjs_list[fr_id][ fr_subj[fr_id] ];
		
				// no sub-subjects? hide
				if(!Object.keys(obj).length) {
					$('.fr_sub_subj_wrap').empty();	
				}
				else {
					var sub_subj = fr_sub_subjs_list[fr_id][ fr_subj[fr_id] ][ fr_sub_subj[fr_id] ],
					
						sel_txt = (fr_sub_subj[fr_id] && typeof(sub_subj) != 'undefined') ? sub_subj.name : fr_any_sub_subj_txt,
						any_vis = (fr_sub_subj[fr_id] && typeof(fr_sub_subjs_list[fr_id][ fr_subj[fr_id] ][ fr_sub_subj[fr_id] ]) != 'undefined') ? '' : 'class="fr_custom_dd_sel"';  
					
					var code = 
					'<div class="fr_sub_subjs_container fr_custom_dd">'+
						'<section>'+ sel_txt +'</section>'+
						
						'<ul class="fr_sub_subjs_list fr_custom_dd_list" style="display: none;">'+
							'<li data-val="any" data-dl="any" '+ any_vis +'>'+ fr_any_sub_subj_txt +'</li>';
					
							$.each(obj, function(id, data) {	
                                if(typeof(JSON.parse( fr_excl_subj[fr_id] )) == 'object' && JSON.parse( fr_excl_subj[fr_id] ).indexOf(id) !== -1) {
                                    return true;    
                                }
                                
								var sel = (fr_sub_subj[fr_id] && fr_sub_subj[fr_id] == id) ? 'class="fr_custom_dd_sel"' : '';
								code += '<li data-val="'+ id +'" data-dl="'+ data.dl +'" '+ sel +'>'+ data.name +'</li>';
							});
				
					code += 
						'</ul>'+
					'</div>';		
			
					$('.fr_sub_subj_wrap').html(code);	
				}
			};
			
			// on init - if is not shortcode forced
			if(!$('[name="fr_forced_sub_subj"]').length) {
				sub_subj_dd_manag();
			}
			
			
			
			
			////////////////////////////////////////
			//// FAQ FETCH, SEARCH & DISPLAY
			
			// fetch
			var fetch_faqs = function() {
				if(is_acting) {
					return false;	
				}
				is_acting = true;
				
				$searchbox.find('.fr_faq_search').slideUp(300);
				$searchbox.find('.fr_faq_search input').prop('disabled', 'disabled');
				$searchbox.find('.fr_matching_faqs').html(fr_loader_code);
				
				var data = {
					fr_f_ajax	: 'get_faqs',
					fr_id		: fr_id,
					subj		: fr_subj[fr_id],
					sub_subj	: ($('.fr_sub_subjs_container').length) ? fr_sub_subj[fr_id] : 0,
					req_src		: $searchbox.data('req-src'),
                    excl_subj   : JSON.parse( fr_excl_subj[fr_id] ),
				};
				$.post(location.href, data, function(response) {
					is_acting = false;
					$searchbox.find('.fr_faq_search input').removeAttr('disabled');
					
					$searchbox.find('.fr_matching_faqs').html(response);
					fr_live_faq_search();
					
					// if there was a search - perform again
					if($searchbox.find(".fr_faq_search input").length && $searchbox.find(".fr_faq_search input").val().length > 2) {
						$searchbox.find(".fr_faq_search input").trigger('keyup');
					}
					
					// if coming from a deeplinkin action - open again the FAQ
					if(deepl_parts['faq']) {
						$(deepl_parts['faq']).trigger('click');
						deepl_parts = deepl_parts_bkp;
					}
				});
			};	
			
			
			
			// search
			var fr_live_faq_search = function() {		
				var fr_lfs_cache = {};
				
				// build an array with FAQ searchable elements
				$searchbox.find('.fr_faqs_list li').each(function(i, v) {
				   
				   var searchable = $(this).text() +' '+ $(this).data('searchable'); 
				   fr_lfs_cache[ $(this).data('val') ] = searchable.toLowerCase();
				});
				
		
				// bind keypress
				$searchbox.on('keyup input', ".fr_faq_search input", function() {
					if(!$searchbox.find('.fr_faqs_list li').length) {
                        return false;
                    }
					
					if(typeof(fr_lfs_acting) != 'undefined') {
                        clearTimeout(fr_lfs_acting);
                    }
					fr_lfs_acting = setTimeout(function() {
						
						$searchbox.find('.fr_no_result').hide();
						back_to_faqs();	
						
						var $input = $searchbox.find('.fr_faq_search input'), 
						src_string = $.trim( $input.val() );
						
						src_string = src_string.replace(',', '').replace('.', '').replace('?', ''); 
						

						if(src_string.length > 2 && $input.val() != $input.attr('placeholder')) { // dunno why, but I had to check the placeh for a customer..
							var src_arr = src_string.toLowerCase().split(' ');
							var matching = [];
		
							// FAQ cyle and check eac searched term 
							$.each(fr_lfs_cache, function(id, text) {
								$.each(src_arr, function(i, word) {						
									if( text.indexOf(word) !== -1 ) {
										
										matching.push( parseInt(id, 10) );
										return false;	
									}
								});
							});
							
							// hide/show FAQ headings
							$searchbox.find('.fr_faqs_list li').each(function(i, v) {
								( $.inArray( $(this).data('val'), matching) !== -1 ) ? $(this).clearQueue().fadeIn(200) : $(this).clearQueue().fadeOut(200);
							});
							
							if(!matching.length) {
								setTimeout(function() {
									$searchbox.find('.fr_no_result').clearQueue().fadeIn(200);
								}, 300);
							}
                            
                            $searchbox.find('.fr_faq_search').addClass('fr_is_searching');
						}
						else {
                            $searchbox.find('.fr_faq_search').removeClass('fr_is_searching');
							($searchbox.data('req-src')) ? $searchbox.find('.fr_faqs_list li').clearQueue().fadeOut(200) : $searchbox.find('.fr_faqs_list li').clearQueue().fadeIn(200);
						}
					}, 300);
				});
			};
			fr_live_faq_search(); // on init
        
        
            // clear search
            $searchbox.on('click', '.fr_clear_search', function(e) {
                $searchbox.find('input').val('').trigger('keyup');        
            });
			
			
			
			// display FAQ content on click
			$searchbox.on('click', '.fr_faqs_list li:not(.fr_sel_faq)', function(e) {		
				if(is_acting) {
					return false;	
				}
				fr_faq[fr_id] = $(this).data('val');
				
				// forcing FAQ's page opening?
				if(fr_only_faq_pag) {
					window.open(fr_siteurl +'?p='+ fr_faq[fr_id], '_blank');
					return false;
				}
				
				// normal execution
				is_acting 		= true;
				fr_faq[fr_id] 	= $(this).data('val');
				
				fr_set_dl();
				$searchbox.find('.fr_faqs_list li').removeClass('fr_sel_faq');
				$(this).addClass('fr_sel_faq');
				
				$(this).parents('.fr_faqs_inner_wrap').addClass('fr_chosen_faq');
				$searchbox.find('.fr_faq_search').slideUp(300);
				
				// scroll to FAQ text
				var page_scroll = $(window).scrollTop(),
					new_scroll	= $searchbox.find('.fr_faqs_inner_wrap').offset().top - 100;
					
				if(page_scroll > new_scroll) {
					$('html, body').animate({'scrollTop': new_scroll}, 300);	
				}

				
				// check in cache
				if(typeof(fr_faq_cache[ fr_faq[fr_id] ]) != 'undefined') {
					$searchbox.find('.fr_faq_container').html(fr_faq_cache[ fr_faq[fr_id] ]);
					is_acting = false;
				}
				
				// ajax
				else {
					$searchbox.find('.fr_faq_container').html(fr_loader_code);
					
					var data = {
						fr_f_ajax	: 'load_faq',
						fid			: fr_faq[fr_id]
					};
					$.post(location.href, data, function(response) {
						fr_faq_cache[ fr_faq[fr_id] ] = response;
						
						$searchbox.find('.fr_faq_container').html(response);
						is_acting = false;
					});
				}
			});
			
			
		
			// back to FAQs list
			var back_to_faqs = function(on_dd_change) {
				if(!$searchbox.find('.fr_chosen_faq').length) {
					return false;	
				}
				
				$searchbox.find('.fr_faqs_inner_wrap').removeClass('fr_chosen_faq');	
				$searchbox.find('.fr_faqs_list li').removeClass('fr_sel_faq');
				
				fr_faq[fr_id] = false;
				if($searchbox.find('.fr_faqs_list li').length > 1 && typeof(on_dd_change) == 'undefined') {
					$searchbox.find('.fr_faq_search').slideDown(250);
				}
				
				// animate the container to avoid jumps after the change
				var $fc = $searchbox.find('.fr_faq_container');
				$fc.css('height', $fc.height());
				$fc.animate({height : $searchbox.find('.fr_faqs_list').outerHeight(true)}, 700);
				
				if(typeof(on_dd_change) == 'undefined') {
					fr_faq[fr_id] = false;	
					fr_set_dl();
					
					is_acting = true;
				}	
			
				setTimeout(function() {
					$searchbox.find('.fr_faq_container').css('height', 'auto').empty();
					is_acting = false;
				}, 750);
			};
			$searchbox.on('click', '.fr_back_to_faqs', function(e) {
				e.stopPropagation();
				back_to_faqs();
			});

	}; // end encapsulation
	
	
	
	
	//////////////////////////////////////////////////////////////////////////////////////
	
	
	
	
	////////////////////////////////////////
	//// DEEPLINK 
	
	// set
	var fr_set_dl = function(replaceState) {
        if(fr_no_deepling || !fr_is_faq_search_pag || fr_skip_deepl || (!$('.fr_subjs_list .fr_custom_dd_sel').length && !$('input[name=fr_faq_subj_dl]').length)) {
			return false;	
		}
		var url_parts = [fr_faq_pag_baseurl];
		
		// subject 
		var subj_part = ($('input[name=fr_faq_subj_dl]').length) ? $('input[name=fr_faq_subj_dl]').val() : $('.fr_subjs_list .fr_custom_dd_sel').data('dl'); 
		url_parts.push(subj_part); 
		
				
		// sub-subject?
		if(!fr_no_sub_subjs) {
			if($('.fr_sub_subjs_list .fr_custom_dd_sel').length) {
				url_parts.push( $('.fr_sub_subjs_list .fr_custom_dd_sel').data('dl') );

			}
			else {
				// if no sub-subject for this subject but there's a chosen FAQ, use "any"
				if(fr_faq[fr_id] && $('.fr_faqs_list [data-val='+ fr_faq[fr_id] +']').length) {
					url_parts.push('any');	
				}
			}
		}
		
		// chosen FAQ
		if(fr_faq[fr_id] && $('.fr_faqs_list [data-val='+ fr_faq[fr_id] +']').length) {
			url_parts.push( $('.fr_faqs_list [data-val='+ fr_faq[fr_id] +']').data('dl'));		
		}
		
		if(typeof(replaceState) == 'undefined') {
			history.pushState(null, null, url_parts.join('/'));	
		} else {
			history.replaceState(null, null, url_parts.join('/'));		
		}
	};
	
	
	
	// track URL changes
	window.onpopstate = function(e) {
		if(fr_no_deepling) {
			return true;
		}	
		
		fr_onpopstate = true;
		fr_skip_deepl = true;
		
		var raw_parts 	= untrailingslashit(location.href).replace(fr_faq_pag_baseurl+'/', '');
			parts 		= (raw_parts == untrailingslashit(fr_faq_pag_baseurl)) ? [] : raw_parts.split('/'),
			parts_count	= parts.length;
		
		// no params - just go back to FAQs lists and leave the chosen subject
		if(!parts_count) {
			$('.fr_sub_subjs_list li[data-val="any"]').trigger('click');
			
			fr_sub_subj[fr_id] = 'any';
			back_to_faqs();
		}
		else {
			deepl_parts['subj'] = '.fr_subjs_list li[data-dl="'+ parts[0] +'"]';

			if(parts_count === 1) {
				if(fr_no_sub_subjs) {
					deepl_parts['sub_subj'] = false;
					deepl_parts['faq']		= false;		
				} else {
					deepl_parts['sub_subj'] = '.fr_sub_subjs_list li[data-dl="any"]';
					deepl_parts['faq']		= false;		
				}
			}
			else if(parts_count === 2) {
				if(fr_no_sub_subjs) {
					deepl_parts['sub_subj'] = false;
					deepl_parts['faq']		= '.fr_faqs_list li[data-dl="'+ parts[1] +'"]';		
				} else {
					deepl_parts['sub_subj'] = '.fr_sub_subjs_list li[data-dl="'+ parts[1] +'"]';
					deepl_parts['faq']		= false;		
				}
			}
			else {
				if(fr_no_sub_subjs) {
					deepl_parts['sub_subj'] = false;
					deepl_parts['faq']		= parts[1];		
				} else {
					deepl_parts['sub_subj'] = '.fr_sub_subjs_list li[data-dl="'+ parts[1] +'"]';
					deepl_parts['faq']		= '.fr_faqs_list li[data-dl="'+ parts[2] +'"]';		
				}	
			}
			
			// if subject is the same
			if($(deepl_parts['subj']).hasClass('fr_custom_dd_sel')) {

				// if sub-subject is the same just change FAQ
				if(fr_no_sub_subjs || $(deepl_parts['sub_subj']).hasClass('fr_custom_dd_sel')) {
					
					if(deepl_parts['faq']) {
						$(deepl_parts['faq']).trigger('click');	
					} else {
						back_to_faqs();	
					}
					
					deepl_parts = deepl_parts_bkp;
				}
				
				else  {
					// reset FAQ selection 
					deepl_parts['faq'] = false;
					
					fr_onpopstate = false; // allow faqs fetching on sub_subj change
					$(deepl_parts['sub_subj']).trigger('click');
				}	
			}
			
			// otherwise change subject and then try changing sub-subj
			else {
				// reset FAQ selection 
				deepl_parts['faq'] 		= false;

				$(deepl_parts['subj']).trigger('click');	
				
				if(deepl_parts['sub_subj'] && deepl_parts['sub_subj'] != 'any' && typeof(fetch_faqs) != 'undefined') {
					setTimeout(function() {
						fr_onpopstate = false; // allow faqs fetching on sub_subj change	
						$(deepl_parts['sub_subj']).trigger('click');
					}, 10);
					
					fetch_faqs();
				}
			}
		}
		
		setTimeout(function() {
			fr_onpopstate = false;
			fr_skip_deepl = false;
		}, 20);
	};
	
	
	// untrailingslashit clone
	var untrailingslashit = function(string) {
		if(string.slice(-1) == '/') {
			return string.substr(0, (string.length - 1));	
		}
		
		return string;
	}
	
	
	

	
	//////////////////////////////////////////////////////////////////////////////////////
	
	
	
	
	////////////////////////////////////////
	//// FAQ CHOICES MANMAGEMENT
	
	//fr_faq_choices_made = {};
	
	/* GLOBAL VARS	   
		fr_faq_choices
		fr_faq_imgs
		fr_faq_links
	*/
	
	
	// handle choices dropdown
	$(window).on('fr_dd_change', function(e, $dd, sel_val) {
		if(!$dd.hasClass('fr_faq_choice_dd')) {
			return true;	
		}

		var section_id = $dd.parents('.fr_faq_choice_wrap').first().data('for-choice'); 
		populate_faq_after_choice(section_id, sel_val);
	});
	
	
	
	// populate FAQ after dropdown choice: section_id = mother section id, choice_id = new choice id  
	var populate_faq_after_choice = function(section_id, choice_id) {
		
		// prior checks
		if(typeof(fr_faq_choices) != 'object') {
			console.error('faq choices not found');
			return false;	
		}		
		var $wrap 	= $('[data-for-choice="'+ section_id +'"]'),
			c_data	= (typeof(fr_faq_choices[choice_id]) != 'object') ? false : fr_faq_choices[choice_id]; 
		
		// further checks	
		if(!$wrap.length) {
			console.error('wrapper not found');
			return false;		
		}
		if(!c_data) {
			console.error('choice not found');
			return false;		
		}
		
			
		// is there already any code? - remove it and clean choices history
		if($('[data-for-choice="'+ section_id +'"] > .fr_faq_choice_wrap').length) {
			$('[data-for-choice="'+ section_id +'"] > .fr_faq_choice_wrap').remove();
			
			/*var new_choices_made = {};
			$.each(fr_faq_choices_made, function(i, v) {
				
				if(i == section_id) {
					return false;	
				} else {
					new_choices_made[i] = v;	
				}
			}); 
			fr_faq_choices_made = new_choices_made;*/
		}
		
		
		//// build choice block ////				
		var code = 
		'<div class="fr_faq_choice_wrap" data-for-choice="'+ choice_id +'">';
			var txt = c_data.txt;
		
			//// text
			// use default one if "on choice" says so
			if(c_data.on_choice == 'def_solution') {
				code += '<div class="fr_faq_txt">'+ $('#fr_solution_case_wrap').html() +'</div>'; 	
			}
			
			else if(c_data.on_choice == 'def_user_act') {
				code += '<div class="fr_faq_txt">'+ $('#fr_user_act_case_wrap').html() +'</div>'; 			
			}
					
			else if(c_data.txt) {
				
				// headings must be replaced with h5
				$.each(['h1', 'h2', 'h3', 'h4', 'h6'], function(i, v) {
					txt = txt.frReplaceAll('&lt;'+v , '<h5');
				});
				
				
				// replace &lt; &gt; with symbols to allow direct HTML 
				// targeted tags
				$.each(['iframe', 'img', 'table', 'tr', 'td', 'th', 'span', 'i', 'button', 'a', 'small'], function(i, v) {
					txt = txt.frReplaceAll('&lt;'+v , '<'+v);
				});
				
				// fix ending tag
				txt = txt.frReplaceAll('&gt;', '>'); 
				//console.log(txt); // debug
				
				
				code += '<div class="fr_faq_txt">'+ txt +'</div>'; 	
			}


			// images gallery
			if(c_data.gallery && c_data.gallery.length) {
				code += faq_choice_gallery(choice_id, c_data.gallery );
			}
			
			
			// knowlewdge-base links
			if(c_data.kb && c_data.kb.length) {
				code += faq_choice_kb( c_data.kb );
			}
			
			
			// if brings to another question
			if(c_data.on_choice == 'question') {
				code += new_choices_dd(c_data.new_quest, c_data.choices);	
			}
	
		
		code += '</div>';
		$('[data-for-choice="'+ section_id +'"]').append(code);

		//fr_faq_choices_made[ section_id ] = choice_id;
	};


	
	
	var faq_choice_gallery = function(choice_id, imgs_array) {
		
		// wait till code is in the page
		setTimeout(function() {
			
			// apply justified gallery
			$('[data-for-choice="'+ choice_id +'"] .fr_choice_gall_inner').justifiedGallery({
				rowHeight 		: fr_gall_img_h,
				maxRowHeight 	: '200%',
				lastRow 		: 'nojustify',
				margins 		: 7,
				border			: 0
			});
			
			// attach lightbox to gallery
			$('[data-for-choice="'+ choice_id +'"] .jg-entry').simpleLightbox({
				sourceAttr 		: 'href',
				fileExt			: false, // must use to fix lb bug
				className		: 'fr_lb',
				history			: false,
				showCounter		: false,
				disableScroll	: false // tanto non funge...
			});
		}, 10);
		
		
		var code = 
		'<div class="fr_choice_gall_wrap">'+
			'<div class="fr_choice_gall_inner">';
		
				$.each(imgs_array, function(i, img_id) {	
					if(fr_faq_imgs && typeof(fr_faq_imgs[img_id]) != 'undefined') {
						
						code +=
						'<a href="'+ fr_faq_imgs[img_id].full +'">' +
							'<img src="'+ fr_faq_imgs[img_id].thumb +'" alt="" />'+
						'</a>';
					}
				});
			
			return code +
			'</div>'+
		'</div>';
	};
	
	
	
	var faq_choice_kb = function(links_array) {
		var code = 
		'<h6 class="fr_choice_kb_legend">'+ fr_kb_legend +'</h6>'+
		'<ul class="fr_choice_kb">';
		
			$.each(links_array, function(i, kb_id) {
				if(typeof(fr_faq_links) == 'object' && typeof(fr_faq_links[kb_id]) != 'undefined') {

					code += '<li><a href="'+ fr_faq_links[kb_id].url +'" target="_blank">'+ fr_faq_links[kb_id].title +'</a></li>';
				}
			});
		
		return code +
		'</ul>';
	};



	var new_choices_dd = function(new_question, choices) {
		if(typeof(choices) != 'object' || !choices.length) {
			console.error('child choices not found');
			return '';
		}
		
		var code =
		'<hr class="fr_sub_choice_hr" />'+
		'<h4 class="fr_new_question">'+ new_question +'</h4>'+
		'<div class="fr_faq_choice_dd fr_custom_dd">'+
			'<section><em>'+ fr_sel_an_opt_txt +'</em></section>'+
					
			'<ul class="fr_faq_choices_dd fr_custom_dd_list">';
				
				$.each(choices, function(i, choice_id) {
					code += '<li data-val="'+ choice_id +'">'+ fr_faq_choices[choice_id].opt_name +'</li>';	
				});

		code +=
			'</ul>'+
		'</div>';
		
		return code;
	};
	
	
	
	// replacing occurrencies in a string
	String.prototype.frReplaceAll = function(search, replace) {
		if (replace === undefined) {
			return this.toString();
		}
		return this.split(search).join(replace);
	}
	
	
	
	
	//////////////////////////////////////////////////////////////////////////////////////
	
	
	
	
	////////////////////////////////////////
	//// FAQ VOTE
	
	$(document).on('click', '.fr_rating_box:not(.fr_already_voted) span', function(e) {
		var $subj = $(this),
			$wrap = $subj.parents('.fr_rating_box');
			
		$subj.addClass('fr_rating_choice');
			
		$wrap.find('p').fadeTo(350, 0, function() {
			$(this).html(fr_after_vote_txt);
			$(this).fadeTo(350, 1);
		});		
		
		// wait a bit for CSS animations	
		setTimeout(function() {
			$wrap.addClass('fr_already_voted');
		}, 800);
			
		// ajax	
		var data = {
			fr_f_ajax	: 'vote_faq',
			fid			: $wrap.data('fid'),
			fr_vote		: ($subj.hasClass('fr_faq_downvote')) ? 'down' : 'up'
		};
		$.post(location.href, data, function(response) {
			if($.trim(response) != 'success') {
				console.error(response);	
			}
		});
	});

});