<?php 
// WHETHER TO DISPLAY KB tags under articles text


function fr_append_kb_tags($contents) {
	global $post;
	if(!isset($post->post_type) || $post->post_type != 'fr_kb' || !get_option('fr_public_kb_tags')) {return $contents;}
	
	// retrieve article tags
	$args = array(
		'orderby' 	=> 'name',
		'order'		=> 'ASC',
	);
	$tags = wp_get_object_terms($post->ID, 'fr_kb_tags', $args);
	
	if(is_wp_error($tags) || empty($tags)) {
		return $contents;	
	}
	
	// build code
	$layout = get_option('fr_kb_tags_layout', 'links'); 
	$code = '
	<div class="fr_kb_tags_wrap fr_kb_tags_'. $layout .'">
		<strong>'. get_option('fr_kb_tags_legend', '<span class="dashicons dashicons-tag"></span> Tags:') .'</strong>';
		
		$a = 0;
		foreach($tags as $tag) {
			$comma = ($layout == 'links' && $a) ? '<i>,</i>' : '';
			$code .= $comma .'<a href="'. get_term_link($tag->term_id, 'fr_kb_tags') .'">'. $tag->name .'</a>';
			
			$a++;	
		}
		
	return $contents . $code . '</div>';
}
add_filter('the_content', 'fr_append_kb_tags', 900);